<?php
/**
 * ITORIS
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the ITORIS's Magento Extensions License Agreement
 * which is available through the world-wide-web at this URL:
 * http://www.itoris.com/magento-extensions-license.html
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to sales@itoris.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade the extensions to newer
 * versions in the future. If you wish to customize the extension for your
 * needs please refer to the license agreement or contact sales@itoris.com for more information.
 *
 * @category   ITORIS
 * @package    ITORIS_M2_PRODUCT_MASS_ACTIONS
 * @copyright  Copyright (c) 2016 ITORIS INC. (http://www.itoris.com)
 * @license    http://www.itoris.com/magento-extensions-license.html  Commercial License
 */

namespace Itoris\ProductMassActions\Controller\Adminhtml\Product;

use \Magento\Catalog\Model\Product\Link;
use Magento\Framework\Controller\ResultFactory;

class MassRelationsCross extends \Magento\Backend\App\Action
{
    /**
     * @return mixed
     */
    public function execute()
    {
        $filter = $this->_objectManager->create('Magento\Ui\Component\MassAction\Filter');
        $collectionFactory = $this->_objectManager->create('Magento\Catalog\Model\ResourceModel\Product\CollectionFactory');
        $collection = $filter->getCollection($collectionFactory->create());
        $productIds = $collection->getAllIds();
        $method = $this->getRequest()->getParam('method');        
        
        if (is_array($productIds) && count($productIds) > 1) {
            
            //implementing a faster method of copying relations through direct SQL
            $res = $this->_objectManager->get('Magento\Framework\App\ResourceConnection');
            $con = $res->getConnection('write');
            
            //applying to each selected product 
            foreach($productIds as $productId) {
                                
                //first remove old relations
                $con->query("delete from {$res->getTableName('catalog_product_link')} where `product_id`={$productId} and `link_type_id`=".Link::LINK_TYPE_RELATED." order by `link_id`");
                
                foreach($productIds as $productId2) {
                    if ($productId == $productId2) continue;
                    $con->query("insert into {$res->getTableName('catalog_product_link')} set `product_id`={$productId}, `linked_product_id`={$productId2}, `link_type_id`=".Link::LINK_TYPE_RELATED);
                }
            }
        
            $this->messageManager->addSuccess(sprintf(__('%s products have been changed'), count($productIds)));
            
            //invalidate FPC
            $cacheTypeList = $this->_objectManager->create('\Magento\Framework\App\Cache\TypeList');
            $cacheTypeList->invalidate('full_page');

        } else {
            $this->messageManager->addError(__('Please select at least 2 products'));
        }

        return $this->resultFactory->create(ResultFactory::TYPE_REDIRECT)->setPath('catalog/*/index');
    }
    
    protected function getDataHelper() {
        return $this->_objectManager->get('Itoris\ProductMassActions\Helper\Data');
    }
}